#include <stdio.h>
#include <math.h>

#define USE_FLT

#include "common_macros.h"
#include "std_commonflt.h"
#include "geo_code.h"


typedef struct test_data test_data;


typedef test_data* divfuncdata;
#define DIVFUNCDATA divfuncdata


int SRC_TERM( DIVFUNCDATA fc,  TRI *sfrag, TRI *dfrag );


#define DIVFUNC subdivider
# define TERMFUNC SRC_TERM

#  include "divfunc.xmacro"

# undef TERMFUNC
#undef DIVFUNC



#ifndef EQ_TESTLEVEL
# define EQ_TESTLEVEL 1
#endif



struct test_data
{
	TRI t;
	VS vert_set;
};


int main( int argn, char *argc[] )
{
	test_data fc;
	TRI t_clip;
	FLT_TYPE cut1x[ 8 ] =
				{ 1, 2, 3, 4, 5, 6, 7, 8 },
			 cut2x[ 8 ] =
				{ 1, 2, 3, 4, 5, 6, 7, 8 };
	FLT_TYPE cut1y[ 8 ] =
				{ 4, 4, 4, 4, 4, 4, 4, 4 },
			 cut2y[ 8 ] =
				{ -4, -4, -4, -4, -4, -4, -4, -4 };
	size_t i = 0;
	int ires, reti[ 3 ];
	FLT_TYPE retf[ 3 ];
	
	printf( "\n" );
	
	
	/* Set fc.t & fc.t_clip */
	
	fc.t.x[ 0 ] = 0;
	fc.t.y[ 0 ] = 0;
	
	fc.t.x[ 1 ] = 2;
	fc.t.y[ 1 ] = 0;
	
	fc.t.x[ 2 ] = 0;
	fc.t.y[ 2 ] = 2;
	
	
	fc.vert_set.x1 = cut1x;
	fc.vert_set.y1 = cut1y;
	
	fc.vert_set.x2 = cut2x;
	fc.vert_set.y2 = cut2y;
	
	fc.vert_set.count = sizeof( cut1x ) / sizeof( FLT_TYPE );
	
	
	
	printf( "EPSILON = %e;\n-EPSILON = %e;\n\n", (float)( EPSILON ), -(float)( EPSILON ) );
	
	printf( "EQ_TESTLEVEL == %i;\n\n", (int)( EQ_TESTLEVEL ) );
	
#if EQ_TESTLEVEL > 0
	printf
	(
		"( 0.0, 0.0, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, 0.0, EPSILON ) ),
		(int)( GR( 0.0, 0.0, EPSILON ) ),
		(int)( LS( 0.0, 0.0, EPSILON ) ),
		(int)( GREQ( 0.0, 0.0, EPSILON ) ),
		(int)( LSEQ( 0.0, 0.0, EPSILON ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"( 0.0, 0.0, 1.0 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, 0.0, 1.0 ) ),
		(int)( GR( 0.0, 0.0, 1.0 ) ),
		(int)( LS( 0.0, 0.0, 1.0 ) ),
		(int)( GREQ( 0.0, 0.0, 1.0 ) ),
		(int)( LSEQ( 0.0, 0.0, 1.0 ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"( 1.0, 0.0, 1.0 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 1.0, 0.0, 1.0 ) ),
		(int)( GR( 1.0, 0.0, 1.0 ) ),
		(int)( LS( 1.0, 0.0, 1.0 ) ),
		(int)( GREQ( 1.0, 0.0, 1.0 ) ),
		(int)( LSEQ( 1.0, 0.0, 1.0 ) )
	);
	printf
	(
		"( 0.0, 1.0, 1.0 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, 1.0, 1.0 ) ),
		(int)( GR( 0.0, 1.0, 1.0 ) ),
		(int)( LS( 0.0, 1.0, 1.0 ) ),
		(int)( GREQ( 0.0, 1.0, 1.0 ) ),
		(int)( LSEQ( 0.0, 1.0, 1.0 ) )
	);
	
#if EQ_TESTLEVEL > 1
	printf( "\n" );
	
	printf
	(
		"( 1.0, 0.0, 2.0 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 1.0, 0.0, 2.0 ) ),
		(int)( GR( 1.0, 0.0, 2.0 ) ),
		(int)( LS( 1.0, 0.0, 2.0 ) ),
		(int)( GREQ( 1.0, 0.0, 2.0 ) ),
		(int)( LSEQ( 1.0, 0.0, 2.0 ) )
	);
	printf
	(
		"( 0.0, 1.0, 2.0 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, 1.0, 2.0 ) ),
		(int)( GR( 0.0, 1.0, 2.0 ) ),
		(int)( LS( 0.0, 1.0, 2.0 ) ),
		(int)( GREQ( 0.0, 1.0, 2.0 ) ),
		(int)( LSEQ( 0.0, 1.0, 2.0 ) )
	);
#endif
	
	printf( "\n\n\n" );
	
	printf
	(
		"( EPSILON, 0.0, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( EPSILON, 0.0, EPSILON ) ),
		(int)( GR( EPSILON, 0.0, EPSILON ) ),
		(int)( LS( EPSILON, 0.0, EPSILON ) ),
		(int)( GREQ( EPSILON, 0.0, EPSILON ) ),
		(int)( LSEQ( EPSILON, 0.0, EPSILON ) )
	);
	printf
	(
		"( 0.0, EPSILON, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, EPSILON, EPSILON ) ),
		(int)( GR( 0.0, EPSILON, EPSILON ) ),
		(int)( LS( 0.0, EPSILON, EPSILON ) ),
		(int)( GREQ( 0.0, EPSILON, EPSILON ) ),
		(int)( LSEQ( 0.0, EPSILON, EPSILON ) )
	);
	
#if EQ_TESTLEVEL > 1
	printf( "\n" );
	
	printf
	(
		"( -EPSILON, 0.0, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( -EPSILON, 0.0, EPSILON ) ),
		(int)( GR( -EPSILON, 0.0, EPSILON ) ),
		(int)( LS( -EPSILON, 0.0, EPSILON ) ),
		(int)( GREQ( -EPSILON, 0.0, EPSILON ) ),
		(int)( LSEQ( -EPSILON, 0.0, EPSILON ) )
	);
	printf
	(
		"( 0.0, -EPSILON, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, -EPSILON, EPSILON ) ),
		(int)( GR( 0.0, -EPSILON, EPSILON ) ),
		(int)( LS( 0.0, -EPSILON, EPSILON ) ),
		(int)( GREQ( 0.0, -EPSILON, EPSILON ) ),
		(int)( LSEQ( 0.0, -EPSILON, EPSILON ) )
	);
#endif
	
	printf( "\n\n" );
	
	printf
	(
		"( EPSILON, 0.0, -EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( EPSILON, 0.0, -EPSILON ) ),
		(int)( GR( EPSILON, 0.0, -EPSILON ) ),
		(int)( LS( EPSILON, 0.0, -EPSILON ) ),
		(int)( GREQ( EPSILON, 0.0, -EPSILON ) ),
		(int)( LSEQ( EPSILON, 0.0, -EPSILON ) )
	);
#if EQ_TESTLEVEL > 1
	printf
	(
		"( 0.0, EPSILON, -EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, EPSILON, -EPSILON ) ),
		(int)( GR( 0.0, EPSILON, -EPSILON ) ),
		(int)( LS( 0.0, EPSILON, -EPSILON ) ),
		(int)( GREQ( 0.0, EPSILON, -EPSILON ) ),
		(int)( LSEQ( 0.0, EPSILON, -EPSILON ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"( -EPSILON, 0.0, -EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( -EPSILON, 0.0, -EPSILON ) ),
		(int)( GR( -EPSILON, 0.0, -EPSILON ) ),
		(int)( LS( -EPSILON, 0.0, -EPSILON ) ),
		(int)( GREQ( -EPSILON, 0.0, -EPSILON ) ),
		(int)( LSEQ( -EPSILON, 0.0, -EPSILON ) )
	);
	printf
	(
		"( 0.0, -EPSILON, -EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 0.0, -EPSILON, -EPSILON ) ),
		(int)( GR( 0.0, -EPSILON, -EPSILON ) ),
		(int)( LS( 0.0, -EPSILON, -EPSILON ) ),
		(int)( GREQ( 0.0, -EPSILON, -EPSILON ) ),
		(int)( LSEQ( 0.0, -EPSILON, -EPSILON ) )
	);
#endif
	
	printf( "\n\n\n" );
	
	printf
	(
		"( EPSILON, -EPSILON, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( EPSILON, -EPSILON, EPSILON ) ),
		(int)( GR( EPSILON, -EPSILON, EPSILON ) ),
		(int)( LS( EPSILON, -EPSILON, EPSILON ) ),
		(int)( GREQ( EPSILON, -EPSILON, EPSILON ) ),
		(int)( LSEQ( EPSILON, -EPSILON, EPSILON ) )
	);
	printf
	(
		"( EPSILON, -EPSILON, EPSILON * 2 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( EPSILON, -EPSILON, EPSILON * 2 ) ),
		(int)( GR( EPSILON, -EPSILON, EPSILON * 2 ) ),
		(int)( LS( EPSILON, -EPSILON, EPSILON * 2 ) ),
		(int)( GREQ( EPSILON, -EPSILON, EPSILON * 2 ) ),
		(int)( LSEQ( EPSILON, -EPSILON, EPSILON * 2 ) )
	);
	
#if EQ_TESTLEVEL > 1
	printf( "\n" );
	
	printf
	(
		"( EPSILON, -EPSILON, -EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( EPSILON, -EPSILON, -EPSILON ) ),
		(int)( GR( EPSILON, -EPSILON, -EPSILON ) ),
		(int)( LS( EPSILON, -EPSILON, -EPSILON ) ),
		(int)( GREQ( EPSILON, -EPSILON, -EPSILON ) ),
		(int)( LSEQ( EPSILON, -EPSILON, -EPSILON ) )
	);
	printf
	(
		"( EPSILON, -EPSILON, -EPSILON * 2 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( EPSILON, -EPSILON, -EPSILON * 2 ) ),
		(int)( GR( EPSILON, -EPSILON, -EPSILON * 2 ) ),
		(int)( LS( EPSILON, -EPSILON, -EPSILON * 2 ) ),
		(int)( GREQ( EPSILON, -EPSILON, -EPSILON * 2 ) ),
		(int)( LSEQ( EPSILON, -EPSILON, -EPSILON * 2 ) )
	);
	
	printf( "\n\n" );
	
	printf
	(
		"( -EPSILON, EPSILON, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( -EPSILON, EPSILON, EPSILON ) ),
		(int)( GR( -EPSILON, EPSILON, EPSILON ) ),
		(int)( LS( -EPSILON, EPSILON, EPSILON ) ),
		(int)( GREQ( -EPSILON, EPSILON, EPSILON ) ),
		(int)( LSEQ( -EPSILON, EPSILON, EPSILON ) )
	);
	printf
	(
		"( -EPSILON, EPSILON, EPSILON * 2 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( -EPSILON, EPSILON, EPSILON * 2 ) ),
		(int)( GR( -EPSILON, EPSILON, EPSILON * 2 ) ),
		(int)( LS( -EPSILON, EPSILON, EPSILON * 2 ) ),
		(int)( GREQ( -EPSILON, EPSILON, EPSILON * 2 ) ),
		(int)( LSEQ( -EPSILON, EPSILON, EPSILON * 2 ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"( -EPSILON, EPSILON, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( -EPSILON, EPSILON, -EPSILON ) ),
		(int)( GR( -EPSILON, EPSILON, -EPSILON ) ),
		(int)( LS( -EPSILON, EPSILON, -EPSILON ) ),
		(int)( GREQ( -EPSILON, EPSILON, -EPSILON ) ),
		(int)( LSEQ( -EPSILON, EPSILON, -EPSILON ) )
	);
	printf
	(
		"( -EPSILON, EPSILON, EPSILON * 2 )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( -EPSILON, EPSILON, -EPSILON * 2 ) ),
		(int)( GR( -EPSILON, EPSILON, -EPSILON * 2 ) ),
		(int)( LS( -EPSILON, EPSILON, -EPSILON * 2 ) ),
		(int)( GREQ( -EPSILON, EPSILON, -EPSILON * 2 ) ),
		(int)( LSEQ( -EPSILON, EPSILON, -EPSILON * 2 ) )
	);
#endif
	
	printf( "\n\n\n" );
	
	printf
	(
		"( 8 - 4, 2 * 2, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 8 - 4, 2 * 2, EPSILON ) ),
		(int)( GR( 8 - 4, 2 * 2, EPSILON ) ),
		(int)( LS( 8 - 4, 2 * 2, EPSILON ) ),
		(int)( GREQ( 8 - 4, 2 * 2, EPSILON ) ),
		(int)( LSEQ( 8 - 4, 2 * 2, EPSILON ) )
	);
	
	printf
	(
		"( 1, 1, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 1, 1, EPSILON ) ),
		(int)( GR( 1, 1, EPSILON ) ),
		(int)( LS( 1, 1, EPSILON ) ),
		(int)( GREQ( 1, 1, EPSILON ) ),
		(int)( LSEQ( 1, 1, EPSILON ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"( 1, 2, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 1, 2, EPSILON ) ),
		(int)( GR( 1, 2, EPSILON ) ),
		(int)( LS( 1, 2, EPSILON ) ),
		(int)( GREQ( 1, 2, EPSILON ) ),
		(int)( LSEQ( 1, 2, EPSILON ) )
	);
	printf
	(
		"( 2, 1, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( 2, 1, EPSILON ) ),
		(int)( GR( 2, 1, EPSILON ) ),
		(int)( LS( 2, 1, EPSILON ) ),
		(int)( GREQ( 2, 1, EPSILON ) ),
		(int)( LSEQ( 2, 1, EPSILON ) )
	);
	
	printf( "\n\n" );
#endif
	
	
	
	printf
	(
		"test tri:\n v1( %f, %f ),\n v2( %f, %f ),\n v3( %f, %f );\n",
			fc.t.x[ 0 ], fc.t.y[ 0 ],
			fc.t.x[ 1 ], fc.t.y[ 1 ],
			fc.t.x[ 2 ], fc.t.y[ 2 ]
	);
	
	
	printf( "\n\n" );
	
	
	printf
	(
		"v1.x * v1.y - v1.x * v1.y = %e;\n  abs() = %e;\n",
		(float)( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] ),
		(float)abs( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] )
	);
	printf
	(
		"( abs( v1.x * v1.y - v1.x * v1.y ), 0.0, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( abs( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( GR( abs( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( LS( abs( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( GREQ( abs( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( LSEQ( abs( fc.t.x[ 0 ] * fc.t.y[ 0 ] - fc.t.x[ 0 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"v1.x * v2.y - v2.x * v1.y = %e;\n  abs() = %e;\n",
		(float)( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] ),
		(float)abs( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] )
	);
	printf
	(
		"( abs( v1.x * v2.y - v2.x * v1.y )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( abs( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( GR( abs( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( LS( abs( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( GREQ( abs( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) ),
		(int)( LSEQ( abs( fc.t.x[ 0 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 0 ] ), 0.0, EPSILON ) )
	);
	
	printf( "\n" );
	
	printf
	(
		"v3.x * v2.y - v2.x * v3.y = %e;\n  abs() = %e;\n",
		(float)( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] ),
		(float)abs( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] )
	);
	printf
	(
		"( abs( v3.x * v2.y - v2.x * v3.y ), 0.0, EPSILON )\n    { EQ = %i, GR = %i, LS = %i, GREQ = %i, LSEQ = %i };\n",
		(int)( EQ( abs( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] ), 0.0, EPSILON ) ),
		(int)( GR( abs( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] ), 0.0, EPSILON ) ),
		(int)( LS( abs( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] ), 0.0, EPSILON ) ),
		(int)( GREQ( abs( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] ), 0.0, EPSILON ) ),
		(int)( LSEQ( abs( fc.t.x[ 2 ] * fc.t.y[ 1 ] - fc.t.x[ 1 ] * fc.t.y[ 2 ] ), 0.0, EPSILON ) )
	);
	
	
	printf( "\n\n" );
	
	
	ires = VEC_PAR
		(
			fc.t.x[ 0 ], fc.t.y[ 0 ],
			fc.t.x[ 0 ], fc.t.y[ 0 ]
		);
	printf
	(
		"  VEC_PAR( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 0 ], fc.t.y[ 0 ],
		fc.t.x[ 0 ], fc.t.y[ 0 ],
		
		ires
	);
	ires = VEC_PAR
		(
			fc.t.x[ 0 ], fc.t.y[ 0 ],
			fc.t.x[ 1 ], fc.t.y[ 1 ]
		);
	printf
	(
		"  VEC_PAR( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 0 ], fc.t.y[ 0 ],
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		
		ires
	);
	
	ires = VEC_PAR
		(
			fc.t.x[ 1 ], fc.t.y[ 1 ],
			fc.t.x[ 1 ], fc.t.y[ 1 ]
		);
	printf
	(
		"  VEC_PAR( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		
		ires
	);
	
	ires = VEC_PAR
		(
			fc.t.x[ 1 ], fc.t.y[ 1 ],
			fc.t.x[ 2 ], fc.t.y[ 2 ]
		);
	printf
	(
		"  VEC_PAR( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		fc.t.x[ 2 ], fc.t.y[ 2 ],
		
		ires
	);
	
	printf( "\n" );
	
	ires = VEC_PERP
		(
			fc.t.x[ 0 ], fc.t.y[ 0 ],
			fc.t.x[ 0 ], fc.t.y[ 0 ]
		);
	printf
	(
		"  VEC_PERP( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 0 ], fc.t.y[ 0 ],
		fc.t.x[ 0 ], fc.t.y[ 0 ],
		
		ires
	);
	ires = VEC_PERP
		(
			fc.t.x[ 0 ], fc.t.y[ 0 ],
			fc.t.x[ 1 ], fc.t.y[ 1 ]
		);
	printf
	(
		"  VEC_PERP( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 0 ], fc.t.y[ 0 ],
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		
		ires
	);
	
	ires = VEC_PERP
		(
			fc.t.x[ 1 ], fc.t.y[ 1 ],
			fc.t.x[ 1 ], fc.t.y[ 1 ]
		);
	printf
	(
		"  VEC_PERP( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		
		ires
	);
	
	ires = VEC_PERP
		(
			fc.t.x[ 1 ], fc.t.y[ 1 ],
			fc.t.x[ 2 ], fc.t.y[ 2 ]
		);
	printf
	(
		"  VEC_PERP( %f, %f,  %f, %f ) : %i;\n",
		fc.t.x[ 1 ], fc.t.y[ 1 ],
		fc.t.x[ 2 ], fc.t.y[ 2 ],
		
		ires
	);
	
	
	printf( "\n\n" );
	
	
	printf( "vs count: %i;\n", (int)fc.vert_set.count );
	i = 0;
	while( i < fc.vert_set.count )
	{
		printf
		(
			"  vs ( x1 = %f, y1 = %f ), ( x2 = %f, y2 = %f ) [ %i ];\n",
			fc.vert_set.x1[ i ], fc.vert_set.y1[ i ],
			fc.vert_set.x2[ i ], fc.vert_set.y2[ i ],
			(int)i
		);
		
		ires = FIND_INTERS ( &( fc.t ),  fc.vert_set.x1[ i ], fc.vert_set.y1[ i ],  fc.vert_set.x2[ i ], fc.vert_set.y2[ i ],    reti, retf );
		printf( "  FIND_INTERS( &test_tri, x1, y1,  x2, y2,  &reti, &retf) : %i;\n", ires );
		printf( "   reti = { %i, %i, %i };\n",  reti[ 0 ], reti[ 1 ], reti[ 2 ] ),
		printf( "   retf = { %f, %f, %f };\n",  retf[ 0 ], retf[ 1 ], retf[ 2 ] );
		
		printf( "\n" );
		++i;
	}
	
	printf
	(
		"input tri:\n v1( %f, %f ),\n v2( %f, %f ),\n v3( %f, %f );\n",
			fc.t.x[ 0 ], fc.t.y[ 0 ],
			fc.t.x[ 1 ], fc.t.y[ 1 ],
			fc.t.x[ 2 ], fc.t.y[ 2 ]
	);

	
	subdivider( &fc,  &( fc.t ), &( fc.t ), &( fc.vert_set ) );		/* Temp. Reduce output. */
	return( 0 );
}


int SRC_TERM( DIVFUNCDATA fc,  TRI *sfrag, TRI *dfrag )
{
	printf
	(
		"SRC_TERM tri: v1( %f, %f ), v2( %f, %f ), v3( %f, %f )\n",
		
		(float)sfrag->x[ 0 ], (float)sfrag->y[ 0 ],
		(float)sfrag->x[ 1 ], (float)sfrag->y[ 1 ],
		(float)sfrag->x[ 2 ], (float)sfrag->y[ 2 ]
	);
	
	return( 1 );
}
